Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR0LibSharedFolders.c
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR0LibSharedFolders.c	(revision 104836)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR0LibSharedFolders.c	(revision 104837)
@@ -51,12 +51,12 @@
 *   Defined Constants And Macros                                                                                                 *
 *********************************************************************************************************************************/
-#define VBOX_INIT_CALL(a, b, c) \
-    LogFunc(("%s, idClient=%d\n", "SHFL_FN_" # b, (c)->idClient)); \
-    VBGL_HGCM_HDR_INIT(a, (c)->idClient, SHFL_FN_##b, SHFL_CPARMS_##b); \
+#define VBOX_INIT_CALL(a, b, c, d) \
+    LogFunc(("%s, idClient=%d\n", #b, (c)->idClient)); \
+    VBGL_HGCM_HDR_INIT(a, (c)->idClient, b, d); \
     (a)->fInterruptible = false /* Currently we do like nfs with -o hard (default). */
 
-#define VBOX_INIT_CALL_EX(a, b, c, a_cbReq) \
-    LogFunc(("%s, idClient=%d\n", "SHFL_FN_" # b, (c)->idClient)); \
-    VBGL_HGCM_HDR_INIT_EX(a, (c)->idClient, SHFL_FN_##b, SHFL_CPARMS_##b, a_cbReq); \
+#define VBOX_INIT_CALL_EX(a, b, c, a_cbReq, d) \
+    LogFunc(("%s, idClient=%d\n", #b, (c)->idClient)); \
+    VBGL_HGCM_HDR_INIT_EX(a, (c)->idClient, b, d, a_cbReq); \
     (a)->fInterruptible = false /* Currently we do like nfs with -o hard (default). */
 
@@ -107,5 +107,5 @@
     VBGLIOCHGCMCALL callInfo;
 
-    VBOX_INIT_CALL(&callInfo, SET_UTF8, pClient);
+    VBOX_INIT_CALL(&callInfo, SHFL_FN_SET_UTF8, pClient, SHFL_CPARMS_SET_UTF8);
     rc = VbglR0HGCMCall(pClient->handle, &callInfo, sizeof(callInfo));
 /*    Log(("VBOXSF: VbglR0SfSetUtf8: VbglR0HGCMCall rc = %#x, result = %#x\n", rc, data.callInfo.Hdr.rc)); */
@@ -133,5 +133,5 @@
     VBoxSFQueryMappings data;
 
-    VBOX_INIT_CALL(&data.callInfo, QUERY_MAPPINGS, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_QUERY_MAPPINGS, pClient, SHFL_CPARMS_QUERY_MAPPINGS);
 
     data.flags.type                      = VMMDevHGCMParmType_32bit;
@@ -159,5 +159,5 @@
     VBoxSFQueryMapName data;
 
-    VBOX_INIT_CALL(&data.callInfo, QUERY_MAP_NAME, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_QUERY_MAP_NAME, pClient, SHFL_CPARMS_QUERY_MAP_NAME);
 
     data.root.type                   = VMMDevHGCMParmType_32bit;
@@ -178,5 +178,5 @@
     VBoxSFMapFolder data;
 
-    VBOX_INIT_CALL(&data.callInfo, MAP_FOLDER, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_MAP_FOLDER, pClient, SHFL_CPARMS_MAP_FOLDER);
 
     data.path.type                    = VMMDevHGCMParmType_LinAddr;
@@ -212,5 +212,5 @@
     VBoxSFUnmapFolder data;
 
-    VBOX_INIT_CALL(&data.callInfo, UNMAP_FOLDER, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_UNMAP_FOLDER, pClient, SHFL_CPARMS_UNMAP_FOLDER);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -230,5 +230,5 @@
     VBoxSFCreate data;
 
-    VBOX_INIT_CALL(&data.callInfo, CREATE, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_CREATE, pClient, SHFL_CPARMS_CREATE);
 
     data.root.type                    = VMMDevHGCMParmType_32bit;
@@ -253,5 +253,5 @@
     VBoxSFClose data;
 
-    VBOX_INIT_CALL(&data.callInfo, CLOSE, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_CLOSE, pClient, SHFL_CPARMS_CLOSE);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -273,5 +273,5 @@
     VBoxSFRemove data;
 
-    VBOX_INIT_CALL(&data.callInfo, REMOVE, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_REMOVE, pClient, SHFL_CPARMS_REMOVE);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -295,5 +295,5 @@
     VBoxSFRename data;
 
-    VBOX_INIT_CALL(&data.callInfo, RENAME, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_RENAME, pClient, SHFL_CPARMS_RENAME);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -322,5 +322,5 @@
     VBoxSFRead data;
 
-    VBOX_INIT_CALL(&data.callInfo, READ, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_READ, pClient, SHFL_CPARMS_READ);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -360,5 +360,5 @@
         return VERR_NO_TMP_MEMORY;
 
-    VBOX_INIT_CALL_EX(&pData->callInfo, READ, pClient, cbData);
+    VBOX_INIT_CALL_EX(&pData->callInfo, SHFL_FN_READ, pClient, cbData, SHFL_CPARMS_READ);
 
     pData->root.type                      = VMMDevHGCMParmType_32bit;
@@ -399,5 +399,5 @@
     VBoxSFWrite data;
 
-    VBOX_INIT_CALL(&data.callInfo, WRITE, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_WRITE, pClient, SHFL_CPARMS_WRITE);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -438,5 +438,5 @@
         return VERR_NO_TMP_MEMORY;
 
-    VBOX_INIT_CALL_EX(&pData->callInfo, WRITE, pClient, cbData);
+    VBOX_INIT_CALL_EX(&pData->callInfo, SHFL_FN_WRITE, pClient, cbData, SHFL_CPARMS_WRITE);
 
     pData->root.type                      = VMMDevHGCMParmType_32bit;
@@ -486,5 +486,5 @@
         return VERR_NO_TMP_MEMORY;
 
-    VBOX_INIT_CALL_EX(&pData->callInfo, WRITE, pClient, cbData);
+    VBOX_INIT_CALL_EX(&pData->callInfo, SHFL_FN_WRITE, pClient, cbData, SHFL_CPARMS_WRITE);
 
     pData->root.type                      = VMMDevHGCMParmType_32bit;
@@ -526,5 +526,5 @@
     VBoxSFFlush data;
 
-    VBOX_INIT_CALL(&data.callInfo, FLUSH, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_FLUSH, pClient, SHFL_CPARMS_FLUSH);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -553,5 +553,5 @@
     VBoxSFList data;
 
-    VBOX_INIT_CALL(&data.callInfo, LIST, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_LIST, pClient, SHFL_CPARMS_LIST);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -592,5 +592,5 @@
     VBoxSFInformation data;
 
-    VBOX_INIT_CALL(&data.callInfo, INFORMATION, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_INFORMATION, pClient, SHFL_CPARMS_INFORMATION);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -625,5 +625,5 @@
     VBoxSFLock data;
 
-    VBOX_INIT_CALL(&data.callInfo, LOCK, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_LOCK, pClient, SHFL_CPARMS_LOCK);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -652,5 +652,5 @@
     VBoxSFReadLink data;
 
-    VBOX_INIT_CALL(&data.callInfo, READLINK, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_READLINK, pClient, SHFL_CPARMS_READLINK);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -676,5 +676,5 @@
     VBoxSFSymlink data;
 
-    VBOX_INIT_CALL(&data.callInfo, SYMLINK, pClient);
+    VBOX_INIT_CALL(&data.callInfo, SHFL_FN_SYMLINK, pClient, SHFL_CPARMS_SYMLINK);
 
     data.root.type                      = VMMDevHGCMParmType_32bit;
@@ -703,5 +703,5 @@
     VBGLIOCHGCMCALL callInfo;
 
-    VBOX_INIT_CALL(&callInfo, SET_SYMLINKS, pClient);
+    VBOX_INIT_CALL(&callInfo, SHFL_FN_SET_SYMLINKS, pClient, SHFL_CPARMS_SET_SYMLINKS);
     rc = VbglR0HGCMCall(pClient->handle, &callInfo, sizeof(callInfo));
 /*    Log(("VBOXSF: VbglR0SfSetSymlinks: VbglR0HGCMCall rc = %#x, result = %#x\n", rc, data.callInfo.Hdr.rc)); */